    require 'libraries/anim8'
    require 'world'
    require 'characters/justice'
    require 'characters/valery'
    require 'characters/rory'
    require 'characters/nightshine'
    require 'dBug'
    require 'camera'
   function player_load()
    errorImg = love.graphics.newImage('sprites/error.png')
    selected_character = {}
    character_1 = justice
    character_2 = valery
    character_3 = rory
    switchCD=0
    player = {active=1,x = 400,y = 900,w = 160, h = 160,
    velX = 100,velY = 100, maxSpeed = 1000, acceleration = 8000, friction = 2000}
    player.jumping = false
    player.grounded = true
    player.health = 5
    player.state = "still"
    player.facing = "right"
    player.damage = 1
    player.doublejump = true
    player.jump_amount = -3000
    player.gravity = 10000
    player.body = love.physics.newBody(world,player.x,player.y,"dynamic")
    player.shape = love.physics.newRectangleShape(150,300)
    player.fixture = love.physics.newFixture(player.body,player.shape)
    player.body:setFixedRotation(true)
    
    justice_load()

    valery_load()

    rory_load()

    nightshine_load()

    sebastian_load()
    --green character
    beetle={
        sprite=love.graphics.newImage('sprites/beetle/beetle.png')
    }
    beetle.portrait = love.graphics.newImage('sprites/beetle/beetle-portrait.png')

    beetle.animations = {}

    beetle.animations.forward = love.graphics.newImage('sprites/error.png')
    beetle.animations.idle = love.graphics.newImage('sprites/error.png')
    --puppet character
    puppet={
        sprite=love.graphics.newImage('sprites/puppet/puppet.png')
    }
    puppet.portrait = love.graphics.newImage('sprites/puppet/puppet-portrait.png')
    --powertool character
    dennis={
        sprite=love.graphics.newImage('sprites/dennis/dennis.png')
    }
    dennis.portrait = love.graphics.newImage('sprites/dennis/dennis-portrait.png')
    
    GPressed = false

end


function update_animations(dt)

justice_animations_update(dt)

valery_animations_update(dt)

rory_animations_update(dt)

nightshine_animations_update(dt)
end

function update_moves(dt)

    justice_moves_update(dt)
    valery_moves_update(dt)
    rory_moves_update(dt)
    

end

function player_control(dt)
    switchCD = switchCD-70 * dt
    
    

   player.x, player.y = player.body:getPosition()
    player.body:setLinearVelocity(player.velX,player.velY)
   
    
   if
    switchCD < 0 then switchCD = 0
    end
   if love.keyboard.isDown("q") and switchCD == 0 then
      player.active=player.active+1
   switchCD = switchCD + 1000 * dt
   end

   
   if player.active > 3 then
       player.active = 1
   end
   
   if love.keyboard.isDown("right","d") and not love.keyboard.isDown('f') and not love.keyboard.isDown('g') and GPressed== false then
    player.state = "right"
    player.facing = "right"
        if player.velX < player.maxSpeed then
            if player.velX + player.acceleration *dt < player.maxSpeed then
            player.velX = player.velX + player.acceleration * dt
                else

                    player.velX = player.maxSpeed
                
                end
        
            end 
        
    elseif love.keyboard.isDown("left","a") and not love.keyboard.isDown('f')and not love.keyboard.isDown('g') and GPressed == false then
        player.state = "left"
        player.facing = "left"
        if player.velX > -player.maxSpeed then
            if player.velX - player.acceleration *dt > -player.maxSpeed then
            player.velX = player.velX - player.acceleration * dt
                else

                    player.velX = -player.maxSpeed
                end
        end
        
        

    elseif love.keyboard.isDown("down","s") and not love.keyboard.isDown('f')and not love.keyboard.isDown('g') and  player.y < 1200 and GPressed == false then
        player.state = "right"
        if player.velY < player.maxSpeed then
            if player.velY + player.acceleration *dt < player.maxSpeed then
            player.velY = player.velY + player.acceleration * dt
                else

                player.velY = player.maxSpeed
                
            end
        
        end 


    elseif love.keyboard.isDown("up","w") and not love.keyboard.isDown('f')and not love.keyboard.isDown('g') and player.y > 750 and GPressed == false then
        player.state = "right"
        if player.velY > -player.maxSpeed then
            if player.velY - player.acceleration *dt > -player.maxSpeed then
            player.velY = player.velY - player.acceleration * dt
                else

                    player.velY = -player.maxSpeed
                
            end
        end
    
    else
        player_friction(dt)
    end
    if not love.keyboard.isDown("left","right","up","down","a","d","w","s","f","g") and GPressed == false then
        player.state = "still"
    end
end





   function player_friction(dt)
        if player.velX > 0 then
            if player.velX - player.friction * dt > 0 then
                player.velX = player.velX - player.friction * dt 
            else 
                player.velX = 0
            end
        elseif player.velX < 0 then
            if player.velX + player.friction * dt < 0 then
                player.velX = player.velX + player.friction * dt
            else
                player.velX = 0
            end
        end

        if player.velY > 0 then
            if player.velY - player.friction * dt > 0 then
                player.velY = player.velY - player.friction * dt 
            else 
                player.velY = 0
            end
        elseif player.velY < 0 then
            if player.velY + player.friction * dt < 0 then
                player.velY = player.velY + player.friction * dt
            else
                player.velY = 0
            end
        end
   end
   

   



function player_jump(key)

    if (key == 'space') then
        if player.grounded == true then
            player.grounded = false
             player.velY = player.jump_amount
            elseif player.doublejump == true then
                
                player.doublejump = false
                player.velY = player.jump_amount * 0.8
            
        end
    end

end

function player_normal(key)
     if (key == 'g') then
        GPressed = true
    end
end



function temp_jumpcheck(dt) --get rid of this as soon as u find a way to check for Z axis

    if player.y < 500 then
    player.grounded = false
    player_gravity()

    end

end



function player_gravity(dt)
    if player.y < 500 then -- temp if statement
    player.velY = player.velY + player.gravity * dt
    end
end

function player_draw()
     
    cam:attach()
   
    love.graphics.draw(background,0,-400,nil,4.0,4.0)
    
    
   
    --party member 1
    if player.active == 1 and player.state == "right" then
       character_1.animations.forward:draw(character_1.forwardSheet,player.x,player.y,nil,3.0,nil,80,90)

    elseif player.active == 1 and player.state == "left" then

        character_1.animations.forward:draw(character_1.forwardSheet,player.x,player.y,nil,-3.0,3.0,80,90)


    elseif player.active == 1 and player.state == "rightspecial" then

        love.graphics.draw(errorImg,player.x,player.y,nil,1.0,nil,80,90)

    elseif player.active == 1 and player.state == "leftspecial" then

        love.graphics.draw(errorImg,player.x,player.y,nil,1.0,nil,80,90)

    elseif player.active == 1 and player.state == "rightnormal" then

        character_1.animations.forwardNormal:draw(character_1.forwardNormalSheet,player.x,player.y,nil,3.0,3.0,80,90)

    elseif player.active == 1 and player.state == "leftnormal" then

        character_1.animations.forwardNormal:draw(character_1.forwardNormalSheet,player.x,player.y,nil,-3.0,3.0,80,90)

    elseif player.active ==1 and player.facing == "right" then
            
            
        character_1.animations.idle:draw(character_1.idleSheet,player.x,player.y,nil,3.0,nil,80,90)
    
    elseif player.active ==1 and player.facing == "left" then
            
            
        character_1.animations.idle:draw(character_1.idleSheet,player.x,player.y,nil,-3.0,3.0,80,90)
    
    
        
    end
    --party member 2
    if player.active == 2 and player.state == "right" then

        character_2.animations.forward:draw(character_2.forwardSheet,player.x,player.y,nil,3.0,nil,80,90)

    elseif player.active == 2 and player.state == "left" then

        character_2.animations.forward:draw(character_2.forwardSheet,player.x,player.y,nil,-3.0,3.0,80,90)

    elseif player.active == 2 and player.state == "rightspecial" then

        love.graphics.draw(errorImg,player.x,player.y,nil,1.0,nil,80,90)

    elseif player.active == 2 and player.state == "leftspecial" then

        love.graphics.draw(errorImg,player.x,player.y,nil,-1.0,1.0,80,90)

    elseif player.active == 2 and player.state == "rightnormal" then

        character_2.animations.forwardNormal:draw(character_2.forwardNormalSheet,player.x,player.y,nil,3.0,3.0,80,90)

    elseif player.active == 2 and player.state == "leftnormal" then

        character_2.animations.forwardNormal:draw(character_2.forwardNormalSheet,player.x,player.y,nil,-3.0,3.0,80,90)

    elseif player.active ==2 and player.facing == "right" then
            
            
        character_2.animations.idle:draw(character_2.idleSheet,player.x,player.y,nil,3.0,nil,80,90)
    
    elseif player.active ==2 and player.facing == "left" then
            
            
        character_2.animations.idle:draw(character_2.idleSheet,player.x,player.y,nil,-3.0,3.0,80,90)
    
    end
    --party member 3

    if player.active == 3 and player.state == "right" then

        character_3.animations.forward:draw(character_3.forwardSheet,player.x,player.y,nil,3.0,nil,80,90)


    elseif player.active == 3 and player.state == "left" then

            character_3.animations.forward:draw(character_3.forwardSheet,player.x,player.y,nil,-3.0,3.0,80,90)
    
    elseif player.active == 3 and player.state == "rightspecial" then

        love.graphics.draw(character_3.animations.forwardspecial,player.x,player.y,nil,3.0,nil,80,90)

    elseif player.active == 3 and player.state == "leftspecial" then

        love.graphics.draw(character_3.animations.forwardspecial,player.x,player.y,nil,-3.0,3.0,80,90)


    elseif player.active ==3 and player.facing == "right" then
            
            
        character_3.animations.idle:draw(character_3.idleSheet,player.x,player.y,nil,3.0,nil,80,90)
    
    elseif player.active ==3 and player.facing == "left" then
            
            
        character_3.animations.idle:draw(character_3.idleSheet,player.x,player.y,nil,-3.0,3.0,80,90)
    
    end
    hitBoxesDraw()
    cam:detach()
   
    
end


function player_beginContact(a, b, collision)
    local nx, ny = collision:getNormal()
   if player.grounded == true then return end
    if a == player.fixture then
           if ny > 0 then
           player_land(collision)
           end
       elseif b == player.fixture then
           if ny < 0 then
               player_land(collision)
           end
       end
   end
   
   function player_endContact(a, b, collision)
       if a == player.fixture or b == player.fixture then
           if player.currentGroundCollision == collision then
               player.grounded = false
           end 
       end
   end
   function player_land(collision)
    player.currentGroundCollision = collision
    player.velY = 0
    player.grounded = true
    player.doublejump = true
end