Enemy = {}

Enemy.__index = Enemy

ActiveEnemys = {}


enemyCounter = 1
local Player = require 'characters/player'
 require 'hitbox'
function Enemy.new(x,y)
local instance = setmetatable({},Enemy)
instance.x = x
instance.y = y
instance.n = enemyCounter
instance.speed = 250
instance.state = "still"
instance.health = 3

instance.toBeRemoved = false
instance.toSpawnNew = false
instance.velX = instance.speed
instance.velY = instance.speed
instance.img = love.graphics.newImage('sprites/enemy/enemy1.png')
instance.width = instance.img:getWidth()
instance.height = instance.img:getHeight()
instance.removal = false
instance.intent = 0
love.graphics.setDefaultFilter('nearest','nearest')
instance.physics = {}
instance.physics.body = love.physics.newBody(world,instance.x,instance.y,"dynamic")
instance.physics.body:setFixedRotation(true)
instance.physics.shape = love.physics.newRectangleShape(instance.width,instance.height*2)
instance.physics.fixture = love.physics.newFixture(instance.physics.body,instance.physics.shape)
instance.physics.fixture:setSensor(true)
enemyCounter =  enemyCounter +1
table.insert(ActiveEnemys, instance)

end


function Enemy:print()

    love.graphics.print("Enemys: " .. #ActiveEnemys,100,50)
end


function Enemy:load()
    
    Enemy.new(200,800)
    Enemy.new(600,800)
    Enemy.new(1000,800)
    Enemy.new(1400,800)
    Enemy.new(1800,800)
    Enemy.new(2200,800)

end

function Enemy:update(dt)
    self:checkRemove()
    self:checkSpawn()
    self:syncPhysics()
    self:checkAttack()
    self:checkRetreat()

    
end

function Enemy:updateAll(dt)
    for i,instance in ipairs(ActiveEnemys) do
        instance:update(dt)


    end
end

function Enemy:checkRemove(EnemyNumber)
    for i, instance in ipairs(ActiveEnemys) do
        if instance == EnemyNumber then
            if EnemyNumber.health  <= 0 then
               
            EnemyNumber:remove()
            end
        end
    end
end

function Enemy:remove(EnemyNumber)
    for i,instance in ipairs(ActiveEnemys) do
        if instance == self and self.health <= 0 then

            instance.toSpawnNew = true

            instance.physics.body:destroy()


            table.remove(ActiveEnemys,i)



            return true
        else
            return false
        end
        
    end

end

function Enemy:syncPhysics()
    
    if state == "playing" then
        for i,instance in ipairs(ActiveEnemys) do
            if instance == self then
            self.x, self.y = self.physics.body:getPosition()
            self.physics.body:setLinearVelocity(self.velX,self.velY)
        if self.x < player.x and self.state ~= "attacking" and self.state ~= "retreating" then
            self.velX = self.speed
            self.state = "right"
        elseif self.x > player.x and self.state ~= "attacking" and self.state ~= "retreating" then
            self.velX = -self.speed
            self.state = "left"
        else
            self.velX = 0
        
        end
        if self.y > player.y then
            
            self.velY = -self.speed

        elseif self.y < player.y then

            self.velY = self.speed
        else
            self.velY = 0

            
        end
    end

    end
end
end





function Enemy:draw()
    if state == "playing" then
        if self.state == "left" or self.state == "attacking" then
            love.graphics.draw(self.img,self.x,self.y,nil,3.0,3.0,self.width/2,self.height/2)
        elseif self.state == "right" or self.state == "attacking" then
            love.graphics.draw(self.img,self.x,self.y,nil,-3.0,3.0,self.width/2,self.height/2)
        end
    end
end

function Enemy.drawAll()

    for i,instance in ipairs(ActiveEnemys) do
        instance:draw()


    end
end

function Enemy.beginContact(a,b,collision)
    for i,instance in ipairs(ActiveEnemys) do
        if a == instance.physics.fixture or b == instance.physics.fixture then
            if a == player.fixture or b == player.fixture then
                
                return true

            end
        end
    end
end

function Enemy:takeDamage(EnemyNumber)
    for i,instance in ipairs(ActiveEnemys) do
    
            EnemyNumber.health = EnemyNumber.health - player.damage --"health, a nil value?"
            instance:checkRemove(EnemyNumber)
            hoverSFX:play()
        
         
    end
end



function Enemy:checkSpawn(EnemyNumber)
    for i, instance in ipairs(ActiveEnemys) do
        if instance:remove() == true then
          
                instance:spawn()
              
        end
    end
end 

function Enemy:spawn()
   

    self.toSpawnNew = false 
    self.new(math.random(-1000,-3000),800)
    self.new(math.random(3000,5000),800)
    
    selectSFX:play()
           
          
        
   

end 

function Enemy:getIntent()
    for i, instance in ipairs(ActiveEnemys) do
            instance.intent = math.random(500)  

   
        if instance.intent > 100 then
            instance.state = "attacking"
        
        elseif instance.intent <= 100 then
            instance.state = "retreating"
        end
    
    end
end

function Enemy:checkAttack()
    for i, instance in ipairs(ActiveEnemys) do
        if instance.state == "attacking" then
            Hitbox:EnemyAttack()
            hoverSFX:play()
        end
    
    end
end

function Hitbox:EnemyAttack()
    local hitBoxCreated = false
    for i, instance in ipairs(ActiveEnemys) do

            if instance.state == "right" then
            Hitbox.new(instance.x+400,instance.y,100,100,Enemy)
            hitboxCreated = true
            elseif instance.state == "left" then
            Hitbox.new(instance.x-400,instance.y,100,100,Enemy)
            hitboxCreated = true
            end
    
        
    end
end

function Enemy:checkRetreat()

end

function Enemy:retreat()

end

