    require 'libraries/anim8'
    require 'world'
    require 'justice'
    require 'valery'
    require 'rory'
    require 'nightshine'
    require 'dBug'
   function player_load()
    errorImg = love.graphics.newImage('sprites/error.png')
    wf = require 'libraries/windfield'
    selected_character = {}
    switchCD=0
    player = {active=1,x = 400,y = 900,w = 160, h = 160,
    velX = 100,velY = 100, maxSpeed = 1000, acceleration = 8000, friction = 2000}
    player.jumping = false
    player.grounded = true
    player.state = "still"
    player.doublejump = true
    player.jump_amount = -2000
    player.gravity = 10000
    player.body = love.physics.newBody(world,player.x,player.y,"dynamic")
    player.shape = love.physics.newRectangleShape(150,300)
    player.fixture = love.physics.newFixture(player.body,player.shape)
    --player.body:setFixedRotation(true)
    
    justice_load()

    valery_load()

    rory_load()

    nightshine_load()

    --green character
    beetle={
        sprite=love.graphics.newImage('sprites/beetle/beetle.png')
    }
    beetle.portrait = love.graphics.newImage('sprites/beetle/beetle-portrait.png')

    beetle.animations = {}

    beetle.animations.forward = love.graphics.newImage('sprites/error.png')
    beetle.animations.idle = love.graphics.newImage('sprites/error.png')
    --puppet character
    puppet={
        sprite=love.graphics.newImage('sprites/puppet/puppet.png')
    }
    puppet.portrait = love.graphics.newImage('sprites/puppet/puppet-portrait.png')
    --powertool character
    dennis={
        sprite=love.graphics.newImage('sprites/dennis/dennis.png')
    }
    dennis.portrait = love.graphics.newImage('sprites/dennis/dennis-portrait.png')
    
end


function update_animations(dt)

justice_animations_update(dt)

valery_animations_update(dt)

rory_animations_update(dt)

nightshine_animations_update(dt)
end

function update_moves(dt)
    justice_moves_update(dt)
    valery_moves_update(dt)
    rory_moves_update(dt)
    

end

function player_control(dt)
    switchCD = switchCD-70 * dt
    
    

   player.x, player.y = player.body:getPosition()
    player.body:setLinearVelocity(player.velX,player.velY)
   
    
   if
    switchCD < 0 then switchCD = 0
    end
   if love.keyboard.isDown("q") and switchCD == 0 then
      player.active=player.active+1
   switchCD = switchCD + 1000 * dt
   end

   
   if player.active > 3 then
       player.active = 1
   end
   
   if love.keyboard.isDown("right","d") and not love.keyboard.isDown('f') and not love.keyboard.isDown('g') then
    player.state = "right"
        if player.velX < player.maxSpeed then
            if player.velX + player.acceleration *dt < player.maxSpeed then
            player.velX = player.velX + player.acceleration * dt
                else

                    player.velX = player.maxSpeed
                
                end
        
            end 
        
    elseif love.keyboard.isDown("left","a") and not love.keyboard.isDown('f')and not love.keyboard.isDown('g') then
        player.state = "left"
        if player.velX > -player.maxSpeed then
            if player.velX - player.acceleration *dt > -player.maxSpeed then
            player.velX = player.velX - player.acceleration * dt
                else

                    player.velX = -player.maxSpeed
                end
        end
        
        

    elseif love.keyboard.isDown("down","s") and player.y < 1370 then
        player.state = "right"
        if player.velY < player.maxSpeed then
            if player.velY + player.acceleration *dt < player.maxSpeed then
            player.velY = player.velY + player.acceleration * dt
                else

                player.velY = player.maxSpeed
                
            end
        
        end 


    elseif love.keyboard.isDown("up","w") and player.y > 610 then
        player.state = "right"
        if player.velY > -player.maxSpeed then
            if player.velY - player.acceleration *dt > -player.maxSpeed then
            player.velY = player.velY - player.acceleration * dt
                else

                    player.velY = -player.maxSpeed
                
            end
        end
    
    else
        player_friction(dt)
    end
    if not love.keyboard.isDown("left","right","up","down","a","d","w","s","f","g") then
        player.state = "still"
    end
end





   function player_friction(dt)
        if player.velX > 0 then
            if player.velX - player.friction * dt > 0 then
                player.velX = player.velX - player.friction * dt 
            else 
                player.velX = 0
            end
        elseif player.velX < 0 then
            if player.velX + player.friction * dt < 0 then
                player.velX = player.velX + player.friction * dt
            else
                player.velX = 0
            end
        end

        if player.velY > 0 then
            if player.velY - player.friction * dt > 0 then
                player.velY = player.velY - player.friction * dt 
            else 
                player.velY = 0
            end
        elseif player.velY < 0 then
            if player.velY + player.friction * dt < 0 then
                player.velY = player.velY + player.friction * dt
            else
                player.velY = 0
            end
        end
   end
   

   



function player_jump(key)

    if (key == 'space') then
        if player.grounded == true then
            player.grounded = false
             player.velY = player.jump_amount
            elseif player.doublejump == true then
                
                player.doublejump = false
                player.velY = player.jump_amount * 0.8
            
        end
    end

end

function temp_jumpcheck(dt) --get rid of this as soon as u find a way to check for Z axis

    if player.y < 500 then
    player.grounded = false
    player_gravity()

    end

end



function player_gravity(dt)
    if player.y < 500 then -- temp if statement
    player.velY = player.velY + player.gravity * dt
    end
end

function player_draw()
    
    love.graphics.push() --attach camera to player and background
    local screenWidth = love.graphics.getWidth()
    local screenHeight = love.graphics.getHeight()
    love.graphics.translate(-player.x+screenWidth/2,-player.y+screenHeight/2)


    
    love.graphics.draw(background,0,-800,nil,3.2,2.3)
   
    --party member 1
    if player.active == 1 and player.state == "right" then
       character_1.animations.forward:draw(character_1.forwardSheet,player.x,player.y,nil,3.0,nil,80,90)

    elseif player.active == 1 and player.state == "left" then

        character_1.animations.forward:draw(character_1.forwardSheet,player.x,player.y,nil,-3.0,3.0,80,90)


    elseif player.active == 1 and player.state == "rightspecial" then

        character_1.animations.forwardspecial:draw(character_1.forwardSpecialSheet,player.x,player.y,nil,3.0,nil,80,90)

    elseif player.active == 1 and player.state == "leftspecial" then

        character_1.animations.forwardspecial:draw(character_1.forwardSpecialSheet,player.x,player.y,nil,-3.0,3.0,80,90)

    elseif player.active ==1 then
            
            
        character_1.animations.idle:draw(character_1.idleSheet,player.x,player.y,nil,3.0,nil,80,90)
    
    
    
        
    end
    --party member 2
    if player.active == 2 and player.state == "right" then

        character_2.animations.forward:draw(character_2.forwardSheet,player.x,player.y,nil,3.0,nil,80,90)

    elseif player.active == 2 and player.state == "left" then

        character_2.animations.forward:draw(character_2.forwardSheet,player.x,player.y,nil,-3.0,3.0,80,90)

    elseif player.active == 2 and player.state == "rightspecial" then

        love.graphics.draw(errorImg,player.x,player.y,nil,1.0,nil,80,90)

    elseif player.active == 2 and player.state == "leftspecial" then

        love.graphics.draw(errorImg,player.x,player.y,nil,-1.0,1.0,80,90)

    elseif player.active == 2 and player.state == "rightnormal" then

        character_2.animations.forwardNormal:draw(character_2.forwardNormalSheet,player.x,player.y,nil,3.0,3.0,80,90)

    elseif player.active == 2 and player.state == "leftnormal" then

        character_2.animations.forwardNormal:draw(character_2.forwardNormalSheet,player.x,player.y,nil,-3.0,3.0,80,90)

    elseif player.active == 2 then

        character_2.animations.idle:draw(character_2.idleSheet,player.x,player.y,nil,3.0,nil,80,90)
    
    end

    --party member 3

    if player.active == 3 and player.state == "right" then

        character_3.animations.forward:draw(character_3.forwardSheet,player.x,player.y,nil,3.0,nil,80,90)


    elseif player.active == 3 and player.state == "left" then

            character_3.animations.forward:draw(character_3.forwardSheet,player.x,player.y,nil,-3.0,3.0,80,90)
    
    elseif player.active == 3 and player.state == "rightspecial" then

        love.graphics.draw(character_3.animations.forwardspecial,player.x,player.y,nil,3.0,nil,80,90)

    elseif player.active == 3 and player.state == "leftspecial" then

        love.graphics.draw(character_3.animations.forwardspecial,player.x,player.y,nil,-3.0,3.0,80,90)


    elseif player.active == 3 and player.state == "still" then
        character_3.animations.idle:draw(character_3.idleSheet,player.x,player.y,nil,3.0,nil,80,90)
    end
    
   love.graphics.pop() 
   
    debugDraw()
end

function player_camera(dt)

    cam:lookAt(player.x,player.y)
    local w = love.graphics.getWidth()
    local h = love.graphics.getHeight()
     --left border
    if cam.x < w/2 then 
        
        cam.x=w/2
 
    end
    --top border
    if cam.y < h/2 then 
        
        cam.y=h/2
 
    end

    local mapW = 800 * 3.2 --width of bg
    local mapH = 1000 * 1.5 --height of bg
   --right border
    if cam.x > (mapW - w/2) then

        cam.x = (mapW - w/2)
    end
   --bottom border
    if cam.y > (mapH - h/2) then

     cam.y = (mapH - h/2)

    end
 
end